package HelloServer;
import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.Registry;
import java.rmi.registry.LocateRegistry;
import java.net.*;
import java.io.*;
import HelloInterface.*;


public class HelloServer  
{
   public static void main(String args[]) 
   {      
      String registryURL;
	  String myName="Donald Duck";
	  int RMIPortNum=1099;

      try
	  {              
         startRegistry(RMIPortNum);
		 System.out.println("before new hello instance instanciated");
         HelloImpl exportedObj = new HelloImpl(myName);
		 System.out.println("new hello instance instanciated");
         registryURL = "rmi://localhost:" + RMIPortNum+ "/HelloInterface";
         Naming.rebind(registryURL, exportedObj);
		 System.out.println("Server registered.  Registry currently contains:");
    
         System.out.println("Hello Server ready.");
      }// end try
      catch (Exception re) {
         System.out.println("Exception in HelloServer.main: " + re);
      } // end catch
  } // end main




   // This method starts a RMI registry on the local host, if it
   // does not already exists at the specified port number.
   private static void startRegistry(int RMIPortNum)
      throws RemoteException{
      try {
         Registry registry = LocateRegistry.getRegistry(RMIPortNum);
         registry.list( );  // This call will throw an exception
                            // if the registry does not already exist
      }
      catch (RemoteException e) { 
         // No valid registry at that port.
/**/     System.out.println
/**/        ("RMI registry cannot be located at port " 
/**/        + RMIPortNum);
         Registry registry = 
            LocateRegistry.createRegistry(RMIPortNum);
/**/        System.out.println(
/**/           "RMI registry created at port " + RMIPortNum);
      }
   } // end startRegistry
     
} // end class
